#include "StdAfx.h"
#include "Baram2.h"

#include "Aimotor.h"

#include "Serialport.h"

#include "PacketGenerator.h"
#include "Receivepacket.h"

#include "MotorNameManager.h"


CAIMotor::CAIMotor(void)
{
	m_pParent = NULL;

	m_iPos = -1;
	m_iPGain = 10;
	m_iDGain = 35;

	m_fCurrent = 0.0f;

	m_iReceivePacketCounter = 0;

	m_Position.x = 100;
	m_Position.y = 100;

}

CAIMotor::CAIMotor(int ID)
{
	m_pParent = NULL;
	m_iID = ID;

	m_sName = MotorNameManager[ID];

	m_iPos = -1;
	m_iPGain = 10;
	m_iDGain = 35;

	m_fCurrent = 0.0f;

	m_iReceivePacketCounter = 0;	

	m_Position.x = 20 + ( ID * 20 );
	m_Position.y = 20 + ( ID * 20 );

	m_bCapture = false;
	m_bToSendPacket = false;

}

CAIMotor::~CAIMotor(void)
{
}

/*
void CAIMotor::SetPosition( int Pos, int Speed, bool bSendPacket )
{
	if( bSendPacket )
	{
		g_SerialPort.Send( CSetPosition( m_iID, Pos, Speed ) );
	}
	else
	{
	}

    m_iPos = Pos;
}
*/

/**
	@remarks
	
	@param int PGain
	@param int DGain
	@param bool bSendPacket
	@return void 
	@date 2004 7 1   10:09:05
*
void CAIMotor::SetGain( int PGain, int DGain, bool bSendPacket )
{
	if( bSendPacket )
	{
	}
	else
	{
		m_iPGain = PGain;
		m_iDGain = DGain;
	}
}
*/

/**
	@remarks
	
	@param bool bRefresh Ŷ  ͸  ΰ? 
	@return int 
	@date 2004 7 1   10:11:03
*/
int CAIMotor::GetPosition() const
{
	return m_iPos;
}


/**
	@remarks
	
	@param		int &PGain
	@param		int &DGain
	@param		bool bRefresh
	
	@return		int 
	
	@author Star.
	@date 2004 7 1   10:19:21
*/
int CAIMotor::GetGain( int &PGain, int &DGain ) const
{
	PGain = m_iPGain;
	DGain = m_iDGain;

	return 0;
}

/**
	@remarks		
		Ϳ  Ŷ    Ŷ Ե ͵ ٸ ,
		 Ŷ  ̿  Ŷ Ͱ  Ǵ 
		͸ ƮѴ.	
		 Լ ش Ϳ  Ŷ ޾  ȣȴ.
	
	@param		IPacket&		SendPacket		 Ŷ
	@param		CReceivePacket& ReceivePacket	 Ŷ
	@param		bool bRefresh
	
	@author Star.
	@date 2004 7 24   7:29:28
*/
void CAIMotor::ReceivePacket( IPacket& SPacket, CReceivePacket& RPacket )
{
	string Name = SPacket.GetName();

	if( Name == "SetPosition" )
	{
		SetCurrent( RPacket[0] );
		m_iPos	   = RPacket[1];
	}

	if( Name == "GetPosition" )
	{
		SetCurrent( RPacket[0] );
		m_iPos	   = RPacket[1];
	}

	if( Name == "ActDown" )
	{
		m_iPos = RPacket[1];
	}

	if( Name == "Rotation360" )
	{
	}

	if( Name == "GetGain" )
	{
		m_iPGain = RPacket[0];
		m_iDGain = RPacket[1];
	}

	if( Name == "SetGain" )
	{
		m_iPGain = RPacket[0];
		m_iDGain = RPacket[1];
	}

	if( Name == "GetMaxCurrent" )
	{
		m_fOverCurrent = RPacket[0];
	}

	m_iReceivePacketCounter++;
}



/**
	@remarks
		 Ѵ.
	
	@param	const int& Val		Ͱ   
	
	@return void 
	
	@author Star.
	@date   2004 7 26   2:06:10
*/
void CAIMotor::SetCurrent( const int& Val )
{
	// ʹ 0~254   ,   18.4 ؾ   ȴ.
	m_fCurrent = (float)( (float)Val * 18.4 );
}



/**
	@remarks
		 Ͱ   ȯ.
	
	@return float	
	
	@author Star.
	@date   2004 7 26   4:07:16
*/
float CAIMotor::GetCurrent() const
{
	return m_fCurrent;
}