#pragma once

#include <assert.h>
#include <map>

#include <Singleton.h>

using namespace std;
using namespace Loki;
using namespace Loki::Private;

//template<int Size = 4> class CReceivePacket;
class CReceivePacket;
class IPacket;

class CAIMotor;

///<  Ŵ ϴ  ڷ map< ID,   >
typedef map< int, CAIMotor* >	MotorMap;


///< Ϳ  Ŷ    Ŷ ޾  ð Ʈ   ޼
#define WM_RECEIVE_ANSWER_PACKET	WM_USER + 10



/**	AIMotor ü ϱ   Ŭ.
 *
 *	@remarks
 *		AIMotorü ü ϱ  AIMotor ü  Ҹ Ѵ.
 *		α׷ ϳ ϸ Ǵ ''  ϱ  Singleton  ߴ.
 *
 *	  Ŭ .
 *		- 1. AIMotor ü   Ͽ ߰Ѵ.
 *		- 2.  ü  û  ü ͸ ȯ   Ѵ.
 *		- 3.  û ְų,  ü Ҹ ʿϴٰ Ǹ  ü ҸŴ.
 *
 *	@author	Star.
*/
class CAIMotorManager
{
	LPDIRECT3DDEVICE9 m_pd3dDevice;

private:
	CAIMotorManager()
	{
	}

	~CAIMotorManager(void)
	{
		DeleteAll();
	}

private:
	MotorMap	m_Map;						///<   ü 

private:
	bool AddMotor( CAIMotor* pMotor );		///< ڿ  ߰

public:
	friend class SingletonHolder< CAIMotorManager >;
	friend struct CreateUsingNew< CAIMotorManager >;

	void DeleteMotor( int id );			///< ڿ ش ID   
	void DeleteAll();						///<   ͸ 

	CAIMotor * NewMotor( int ID );			///<  ڸ   ü ϰ ̸  Ͽ ߰Ѵ.

	void SendGetPositionAll();				///< ϵ ͵  ġ о Ŷ ...


//  Լ   ζ Լ .
public:
	///< ڿ ϵ  ߿ شǴ ID   ͸ ȯѴ.
	CAIMotor * operator [] (int id)
	{
		return m_Map[id];
	}


	///<   ߿ ־ ID  ͸ ãƼ ȯ
	CAIMotor * GetMotor( int id )
	{
		return m_Map[id];
	}

	///<  Ŵ  Ų. (  ͸   Է¹ غ Ѵ. )
	void Reset()
	{
		DeleteAll();
	}

	///< ڰ ϰ ִ  (Map) ȯѴ.
	MotorMap GetMotorMap()
	{
		return m_Map;
	}

public:
	void SetDirect3DDevice( LPDIRECT3DDEVICE9 pDevice )
	{
		m_pd3dDevice = pDevice;
	}
};

///<  Ŵ ̱  .
typedef SingletonHolder< CAIMotorManager > MotorManager;
#define	 AIMotorManager						MotorManager::Instance()
