// CellEdit.cpp : implementation file
//

#include "stdafx.h"
//#include "EditableGrid.h"
#include "CellEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCellEdit

CCellEdit::CCellEdit()
{
	m_brush=NULL;
}

CCellEdit::~CCellEdit()
{
	if (m_brush!=NULL) delete m_brush;
}


BEGIN_MESSAGE_MAP(CCellEdit, CEdit)
	//{{AFX_MSG_MAP(CCellEdit)
		ON_WM_KILLFOCUS()
		ON_WM_CTLCOLOR_REFLECT()
		ON_WM_KEYDOWN()
		ON_WM_GETDLGCODE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCellEdit message handlers
void CCellEdit::OnKillFocus(CWnd* pNewWnd) 
{
	if (pNewWnd!=NULL){
		if (pNewWnd->m_hWnd!=GetParent()->m_hWnd) GetParent()->PostMessage(WM_KEYDOWN,13,0);
						}
	CEdit::OnKillFocus(pNewWnd);
	
}

HBRUSH CCellEdit::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	pDC->SetTextColor(m_textcolor);
	pDC->SetBkColor(m_backcolor);

	return *m_brush;
}

UINT CCellEdit::OnGetDlgCode()
{

	return DLGC_WANTARROWS|DLGC_WANTALLKEYS|DLGC_WANTCHARS;
}

void CCellEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
			
	if (nChar==13) GetParent()->PostMessage(WM_KEYDOWN,nChar,0);
	CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}


BOOL CCellEdit::PreTranslateMessage(MSG* pMsg) 
{
      switch (pMsg->message)
      {
         case WM_KEYDOWN:
         case WM_KEYUP:
            switch (pMsg->wParam)
            {
               case VK_UP:
               case VK_DOWN:
               case VK_LEFT:
               case VK_RIGHT:
               case VK_HOME:
               case VK_END:
                  SendMessage (pMsg->message, pMsg->wParam, pMsg->lParam);
                  // Windowless controls won't be able to call SendMessage.
                  // Instead, just respond to the message here.
                  return TRUE;
            }
            break;
      }
	
	return CEdit::PreTranslateMessage(pMsg);
}

void CCellEdit::ResetColors(COLORREF newtext,COLORREF newback){

	m_textcolor=newtext;
	m_backcolor=newback;
	if (m_brush!=NULL) delete m_brush;
	m_brush=new (CBrush);
	m_brush->CreateSolidBrush(m_backcolor);
	Invalidate(TRUE);

}