// EditFlexGrid.cpp : implementation file
//

#include "stdafx.h"
#include "EditFlexGrid.h"
#include "font.h"
#include ".\editflexgrid.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditFlexGrid
CEditFlexGrid::CEditFlexGrid()
{
	m_font=NULL;
}

CEditFlexGrid::~CEditFlexGrid()
{
if (m_font!=NULL) delete m_font;
}


BEGIN_MESSAGE_MAP(CEditFlexGrid, CMSFlexGrid)
	//{{AFX_MSG_MAP(CEditFlexGrid)
	ON_WM_GETDLGCODE()
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CEditFlexGrid message handlers

BEGIN_EVENTSINK_MAP(CEditFlexGrid, CMSFlexGrid)
    //{{AFX_EVENTSINK_MAP(CEditFlexGrid)
	//}}AFX_EVENTSINK_MAP
	ON_EVENT_REFLECT(CEditFlexGrid, -601 /* DblClick */, OnDblClick, VTS_NONE)
	ON_EVENT_REFLECT(CEditFlexGrid, 73 /* Scroll */, OnScroll, VTS_NONE)
	ON_EVENT_REFLECT(CEditFlexGrid, -602 /* KeyDown */, OnKeyDownFlex, VTS_PI2 VTS_I2)
	ON_EVENT_REFLECT(CEditFlexGrid, 72 /* LeaveCell */, OnLeaveCell, VTS_NONE)
	
END_EVENTSINK_MAP()

void CEditFlexGrid::PreSubclassWindow(){

	m_edit.Create(WS_CHILD|ES_LEFT|ES_AUTOHSCROLL,CRect(0,0,100,100),this,GetDlgCtrlID());
	m_edit.ModifyStyleEx(0,WS_EX_LEFT|WS_EX_LTRREADING|WS_EX_NOPARENTNOTIFY,FALSE);

	CClientDC dc(this);
	m_pixelsperinchx=dc.GetDeviceCaps(LOGPIXELSX);
	m_pixelsperinchy=dc.GetDeviceCaps(LOGPIXELSY);
	LOGFONT log;
	COleFont font=GetFont();
	CY cy=font.GetSize();
	log.lfCharSet=(unsigned char)font.GetCharset();
	log.lfClipPrecision=0;
	log.lfEscapement=0;
	strcpy(log.lfFaceName,font.GetName());
	log.lfHeight= -MulDiv(cy.Lo,m_pixelsperinchy,720000);
	log.lfItalic=(unsigned char)font.GetItalic();
	log.lfOrientation=0;
	log.lfOutPrecision=0;
	log.lfPitchAndFamily=0;
	log.lfQuality=0;
	log.lfStrikeOut=(unsigned char)font.GetStrikethrough();
	log.lfUnderline=(unsigned char)font.GetUnderline();
	log.lfWeight=font.GetWeight();
	log.lfWidth=0;
	if (m_font!=NULL) delete m_font;
	m_font=new CFont;
	m_font->CreateFontIndirect(&log);
	m_edit.SetFont(m_font);
	
			
}

UINT CEditFlexGrid::OnGetDlgCode()
{
 return DLGC_WANTARROWS|DLGC_WANTALLKEYS|DLGC_WANTCHARS;
}

void CEditFlexGrid::OnDblClick() 
{
	long Col = this->GetCol();

	//   ũ  ¶    ̹Ƿ ȿ...
	if( Col == 5 || Col == 6 )
		return;

	if (m_edit.IsWindowVisible()==FALSE) ShowEditBox();	
}

void CEditFlexGrid::OnScroll() 
{
	if (m_edit.IsWindowVisible()==TRUE) HideEditBox();
}

void CEditFlexGrid::OnKeyDownFlex(short FAR* KeyCode, short Shift) 
{
	long Col = this->GetCol();

	//   ũ  ¶    ̹Ƿ ȿ...
	if( Col == 5 || Col == 6 )
		return;


	if (*KeyCode==13){

			if (m_edit.IsWindowVisible()==FALSE) ShowEditBox(); else HideEditBox();

					}
}

void CEditFlexGrid::OnLeaveCell() 
{
	if (m_edit.IsWindowVisible()==TRUE) HideEditBox();	
}


void CEditFlexGrid::ShowEditBox(){
	
	long left,top,w,h;
	unsigned long fore_color,back_color;
	COLORREF m_back,m_text;
	CRect r_window,r_rectedit;
	
	GetWindowRect(&r_window);
	ScreenToClient(&r_window);
	
	left=GetCellLeft();
	top=GetCellTop();
	w=GetCellWidth();
	h=GetCellHeight();
		
	r_rectedit.SetRect((int)(r_window.left+(left)*m_pixelsperinchx/1440),(int)(r_window.top+(top+15)*m_pixelsperinchy/1440),
				(int)(r_window.left+(left+w)*m_pixelsperinchx/1440),(int)(r_window.top+(top+h)*m_pixelsperinchy/1440));
		
	fore_color=GetCellForeColor();
	if (fore_color==0) fore_color=GetForeColor();
	if (OleTranslateColor(fore_color,NULL,&m_text)!=S_OK) m_text=RGB(0,0,0);

	back_color=GetCellBackColor();
	if (back_color==0) back_color=GetBackColor();
	if (OleTranslateColor(back_color,NULL,&m_back)!=S_OK) m_back=RGB(255,255,255);

	m_edit.MoveWindow(&r_rectedit,TRUE);
	m_edit.ResetColors(m_text,m_back);
	m_edit.ShowWindow(SW_SHOW);
	m_edit.SetWindowText("");
	m_edit.SetFocus();
	m_edit.ReplaceSel(GetText());
	m_edit.SetSel(-1,-1,FALSE);
	
}

void CEditFlexGrid::HideEditBox(){
	
	CString s;
	m_edit.GetWindowText(s);
	long row=GetRow();
	long col=GetCol();
	if (row>=GetFixedRows()&&col>=GetFixedCols()) SetTextMatrix(row,col,s);
	m_edit.ShowWindow(SW_HIDE);
					
}


BOOL CEditFlexGrid::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	return CMSFlexGrid::OnMouseWheel(nFlags, zDelta, pt);
}


void CEditFlexGrid::SetString( int row, int col, const CString& str )
{
	SetTextMatrix( row, col, str );
}


void CEditFlexGrid::SetInt( int row, int col, const int val )
{
	CString temp;
	temp.Format( "%d", val );

	SetTextMatrix( row, col, temp );
}


CString CEditFlexGrid::GetString( int row, int col ) 
{
	return GetTextMatrix( row, col );
}


int CEditFlexGrid::GetInt( int row, int col ) 
{
	CString temp = GetTextMatrix( row, col );

	return atoi( temp );
}