#include "StdAfx.h"
#include ".\motion.h"

#include "SerialPort.h"
#include "PacketManager.h"

#include "MotionManager.h"

void CSingleMotion::Run()
{
//	PacketManager.ClearQue();
//	g_SerialPort.ClearBuffer();

	FrameList::iterator iter;

	for( iter = m_FrameList.begin(); iter != m_FrameList.end(); iter++ )
	{
		int ID   = iter->m_iID;
		int Pos  = iter->m_iPos;
		int Speed= iter->m_iSpeed;

		PacketManager.Send( CSetPosition( ID, Pos, Speed ), false );
	}

	for( iter = m_FrameList.begin(); iter != m_FrameList.end(); iter++ )
	{
		int ID   = iter->m_iID;
		int Pos  = iter->m_iPos;
		int Speed= iter->m_iSpeed;

//		PacketManager.Send( CSetPosition( ID, Pos, Speed ), false );
	}
}

void CLinkedMotion::Run()
{
	MotionList::iterator iter;

	for( iter = m_MotionList.begin(); iter != m_MotionList.end(); iter++ )
	{
		//iter->pMotion->Run();
		CMotion* motion = MotionManager[ iter->Name ];
		motion->Run();

		g_SerialPort.Delay( iter->Delay );
	}    
}

void CLinkedMotion::AddMotion( CMotion* pMotion, int Delay )
{
	LINKEDMOTION temp;

	temp.Name	 = pMotion->GetName();
	temp.pMotion = pMotion;
	temp.Delay	 = Delay;

	m_MotionList.push_back( temp );
}

void CLinkedMotion::AddMotion( const string& name, int Delay )
{
	LINKEDMOTION temp;

	temp.Name	 = name;
	temp.Delay	 = Delay;

	m_MotionList.push_back( temp );
}

void CLinkedMotion::RefreshPointer()
{
	MotionList::iterator iter;

	for( iter = m_MotionList.begin(); iter != m_MotionList.end(); iter++ )
	{
		CMotion* motion = MotionManager[ iter->Name ];
		iter->pMotion = motion;
	}
}
void CLinkedMotion::RemoveMotion( const string& name )
{
	MotionList::iterator iter;

	for( iter = m_MotionList.begin(); iter != m_MotionList.end(); iter++ )
	{
		if( (iter->Name) == name )
		{
			m_MotionList.erase( iter );
		}
	}
}