#pragma once

#include <string>
#include <vector>
#include <list>

#include "FrameData.h"


using namespace std;


class CMotionManager;


typedef vector<CFrame>	FrameList;			///<  Ʈ

/**  ϴ Ŭ ü.

	@author Star.
	@date 2004 7 28   12:25:43
*/
class CMotion
{
protected:
	string		m_sName;			///<  ̸
	string		m_sAuthor;			///< ۼ ̸
	string		m_sType;			///< Ÿ

public:
	CMotion( const string& Name )
	{
		m_sType = "CMotion";

		m_sName = Name;
	}

	CMotion( const CMotion& clone )
	{
		m_sType = "CMotion";

		m_sName = clone.m_sName;
		m_sAuthor=clone.m_sAuthor;
	}

	CMotion()
	{
		m_sType = "CMotion";
	}

	virtual ~CMotion(void)
	{
	}

public:
	friend CMotionManager;


public:
	virtual void	Run() = 0;					///<  


public:
	///<  ̸ ȯ
	string GetName()
	{
		return m_sName;
	}

	///<   ȯ
	string GetAuthor()
	{
		return m_sAuthor;
	}

	///<   
	void SetAuthor( const string& name )
	{
		m_sAuthor = name;
	}

	///<  ̸ 
	void SetName( const string& name )
	{
		m_sName = name;
	}
	
	string GetType()
	{
		return m_sType;
	}
};


class CSingleMotion : public CMotion
{
	FrameList	m_FrameList;		///<  Ʈ

public:
	friend CMotionManager;

	CSingleMotion( const CSingleMotion& clone )
	{
		m_sType = "CSingleMotion";

		m_FrameList.clear();
		m_sName = clone.m_sName;
		m_sAuthor=clone.m_sAuthor;
		m_FrameList = clone.m_FrameList;
	}

	CSingleMotion( const string& Name )
	{
		m_sType = "CSingleMotion";

		m_sName = Name;
		m_FrameList.clear();
	}

	CSingleMotion()
	{
		m_sType = "CSingleMotion";
	}

public:
	virtual void Run();

public:
	///<  ߰.
	void	AddFrame( const CFrame& Frame )
	{
		m_FrameList.push_back( Frame );
	}

	///<  Ŭ.
	void	Clear()
	{
		m_FrameList.clear();
	}

	///<   ȯ.
	int		GetFrameCount()
	{
		return m_FrameList.size();
	}

	///< ϴ ӿ  
	CFrame&	operator[] ( int index )
	{
		return m_FrameList[index];
	}

	///< 񱳿
	bool operator == ( const CSingleMotion& rhs )
	{
		if( m_FrameList.size() == rhs.m_FrameList.size() )
		{
			for( int i = 0; i < m_FrameList.size(); i++ )
			{
				if( !( m_FrameList[i] == rhs.m_FrameList[i] ) )
				{
                    return false;
				}
			}

			return true;
		}
		else
			return false;
	}

	///< Կ
	void operator = ( const CSingleMotion& rhs )
	{
		m_FrameList.clear();

		m_FrameList = rhs.m_FrameList;
		m_sName = rhs.m_sName;
		m_sAuthor = rhs.m_sAuthor;
	}
};


struct LINKEDMOTION
{
	string   Name;		///<  ̸
	CMotion* pMotion;	///<  
	int		 Delay;		///< 
};

typedef vector< LINKEDMOTION >	MotionList;			///<  Ʈ

class CLinkedMotion : public CMotion
{
	MotionList	m_MotionList;		///<  Ʈ

public:
	friend CMotionManager;

	CLinkedMotion( const CLinkedMotion& clone )
	{
		m_sType = "CLinkedMotion";

		m_MotionList.clear();
		m_sName = clone.m_sName;
		m_sAuthor=clone.m_sAuthor;
		m_MotionList = clone.m_MotionList;
	}

	CLinkedMotion( const string& Name )
	{
		m_sType = "CLinkedMotion";

		m_sName = Name;
		m_MotionList.clear();
	}

	CLinkedMotion()
	{
		m_sType = "CLinkedMotion";
	}

public:
	virtual void Run();

	void	AddMotion( CMotion* pMotion, int Delay );	///<    ߰
	void	AddMotion( const string& name, int Delay );	///<    ߰
	void	RemoveMotion( const string& name );

	void	RefreshPointer();

public:
	///<   ȯ.
	int		GetMotionCount()
	{
		return m_MotionList.size();
	}

	///< ǸƮ Ŭ
	void	Clear()
	{
		m_MotionList.clear();
	}

	LINKEDMOTION& operator[] ( int index )
	{
		return m_MotionList[index];
	}    
};