#pragma once

#include <string>
#include <map>

#include "Singleton.h"
#include "Motion.h"

using namespace Loki;
using namespace std;


typedef map< string, CMotion* >		MotionMap;


/**  ü ϴ   Ŭ.

	@author Star.
	@date 2004 7 28   12:26:37
*/
class CMotionManager
{
	MotionMap		m_MotionMap;


private:
	CMotionManager(void);
	~CMotionManager(void);

public:
	friend class SingletonHolder< CMotionManager >;
	friend struct CreateUsingNew< CMotionManager >;

	MotionMap& GetMap()
	{
		return m_MotionMap;
	}

	CMotion* operator[] ( const string& name )
	{
		return m_MotionMap[ name ];
	}

public:
	bool AddMotion( const string& name, CMotion* motion, bool bOverwrite = false );
	void Reset();

};


///<  Ŵ ̱  .
typedef SingletonHolder< CMotionManager > CSingleMotionManager;
#define	 MotionManager					   CSingleMotionManager::Instance()
