#pragma once

#include <string>
#include <map>

#include "Singleton.h"

using namespace std;
using namespace Loki;


typedef map< string, int >		IntMap;
typedef map< string, string>	StringMap;
typedef map< string, bool >	BoolMap;

/** α׷ ü ɼ ϴ Ŭ.

	@author Star.
	@date 2004 7 26   4:46:58
*/
class COptionManager
{
	friend class SingletonHolder< COptionManager >;
	friend struct CreateUsingNew< COptionManager >;

private:

	IntMap		m_IntOption;
	StringMap	m_StringOption;
	BoolMap		m_BoolOption;

private:
	COptionManager()
	{
	}

	~COptionManager()
	{
	}

public:
	///< int  ɼ ߰Ѵ.
	void	AddIntOption( const string& Name, const int Val );	

	///< string  ɼ ߰Ѵ.
	void	AddStringOption( const string& Name, const string& Val );

	///< bool  ɼ ߰Ѵ.
	void	AddBoolOption( const string& Name, const bool Val );

public:
	///< ɼ int о´.
    int		GetIntOption( string Name )
	{
		return m_IntOption[ Name ];
	}

	///< ɼ string о´.
	string	GetStringOption( string Name )
	{
		return m_StringOption[ Name ];
	}

	///< ɼ bool о´.
	bool	GetBoolOption( string Name ) 
	{
		return m_BoolOption[ Name ];
	}

public:
	///< ɼ int Ѵ.
    void	SetIntOption( string Name, int Val )
	{
		m_IntOption[ Name ] = Val;
	}

	///< ɼ string Ѵ.
	void	SetStringOption( string Name, const string& Val )
	{
		m_StringOption[ Name ] = Val;
	}

	///< ɼ bool Ѵ.
	void	SetBoolOption( string Name, bool Val ) 
	{
		m_BoolOption[ Name ] = Val;
	}
};


typedef SingletonHolder< COptionManager >		SingleOptionManager;
#define	 OptionManager							SingleOptionManager::Instance()