#pragma once

#include <assert.h>
#include <string>

using namespace std;

/** Ŷ  ü.
	
	g_SerialPort.Send( CSetPosition( ... ) );  , ø Ʈ  Ŷ 
	Ŭ ü̴.
	 Ŷ ϴ  IPacket ӹ Ŭ ̸,
	 ڵ ش Ŷ ϱ  ʿ ڸ   ִ.
	߿ ο Ŷ ߰ϱ ؼ IPacket ӹ޴ Ŭ  ,
	Ʒ  Ģ  Ŭ ڸ ۼϸ ȴ.

	Ŷ  Ģ:
		- 1. ش Ŷ   ID  ڷ ޾Ƴ Ѵ.
		- 2. Ŷ ũ( 4byte, 6byte.. )    ־ Ѵ.
		- 3. Ŭ ̸ ξ "C"   m_sName  ؾ Ѵ.
		- 4.   <b> MakeChecksum()</b> ȣؾ Ѵ. 
			 (  Ϳ  Checksum  ؼ. )
		- 5. m_Data[0] = 0xFF  ʱ⿡ õǾ ִ.

	)
	@code
		class CGetPosition : public IPacket
		{
		public:
			CGetPosition( int ID )
			{
				m_sName = "GetPosition";

				m_iMotorID = ID;
				m_iSize = 4;

				m_Data[1] = ( ( 1 | 5 ) << 5 ) | ID ;
				m_Data[2] = 0x00;
			
				MakeChecksum();
			}
		};
	@endcode
		
	@author Star.
*/
class IPacket
{
protected:
	string	m_sName;			///<  ̸(?)
	BYTE	m_Data[6];			///< Ŷ  

	int		m_iMotorID;			///< Ŷ   ID
	int		m_iSize;			///< Ŷ . ( μ 4Ʈ 6Ʈ   . )
	bool	m_bChecksum;		///< Ŷ    MakeChecksum Լ ȣؾ ϴµ, ȣ ʾ   

public:
	IPacket()
	{
		m_iMotorID = 0;		
		m_bChecksum = false;

		m_iSize = 4;
		m_Data[0] = 0xFF;
	}

	IPacket( const IPacket& clone )
	{
		*this = clone;
	}

	~IPacket()
	{
		// MakeChecksum ȣ  ̲ó
		assert( m_bChecksum == true );
	}

	///< Ŷ ̸ .
	string& GetName()
	{
		return m_sName;
	}

	///< Ŷ   ID.
	int GetMotorID() const
	{
		return m_iMotorID;
	}

    ///< Ŷ  . 
	int GetSize()
	{
		return m_iSize;
	}

	///< Ŷ ۸ .
	BYTE*  GetBuffer()
	{
		return m_Data;
	}

	///< Ŷ   CheckSum  Լ.
	void MakeChecksum()
	{
		if( m_iSize == 4 )
		{
			m_Data[3] = ( m_Data[1] ^ m_Data[2] ) & 0x7F;
		}
		else
		{
			m_Data[5] = ( m_Data[1] ^ m_Data[2] ^ m_Data[3] ^ m_Data[4] ) & 0x7F;
		}

		m_bChecksum = true;
	}

	///< string ĳϴ  ε.
	operator string()
	{
		return m_sName;
	}

	///< ü ٸ IPacketü ϴ .
	

};


///<  ġ ϴ Ŷ.
class CSetPosition : public IPacket
{
public:
	CSetPosition( int ID, int Pos, int Speed )
	{
		m_sName = "SetPosition";

		m_iMotorID = ID;
		m_iSize = 4;

		// ǵ  0(ִ) ~ 4(ּ)
		if( Speed > 4 )
		{
			Speed = 4;
		}
		
		else if( Speed < 0 )
		{
			Speed = 0;
		}

		m_Data[1] = ( ( 1 | Speed ) << 5 ) | ID ;
		m_Data[2] = Pos;
		
		MakeChecksum();
	}
};

///<  ġ о Ŷ.
class CGetPosition : public IPacket
{
public:
	CGetPosition( int ID )
	{
		m_sName = "GetPosition";

		m_iMotorID = ID;
		m_iSize = 4;

		m_Data[1] = ( ( 1 | 5 ) << 5 ) | ID ;
		m_Data[2] = 0x00;
		
		MakeChecksum();
	}
};

///<  ũ ִ Ŷ.
class CActDown : public IPacket
{
public:
	CActDown( int ID )
	{
		m_sName = "ActDown";

        m_iMotorID = ID;
		m_iSize = 4;

		m_Data[1] = ( 6 << 5 ) | ID ;
		m_Data[2] = ( 1 << 4 ) | 0 ;

		MakeChecksum();
	}
};


///<   ϴ Ŷ.
class CPowerDown : public IPacket
{
public:
	CPowerDown( int ID )
	{
		m_sName = "PowerDown";

		m_iMotorID = ID;
		m_iSize = 4;

		m_Data[1] = ( ( 1 | 6 ) << 5 ) | 31 ;
		m_Data[2] = ( ( 1 | 2 ) << 4 ) | 0 ;

		MakeChecksum();
	}
};

///< 360 ȸ .
class CRotation : public IPacket
{
public:
	enum ROTATION
	{
		CW  = 3,
		CCW = 4
	};
		
	CRotation( int ID, enum ROTATION rot, int Speed )
	{
		m_sName = "Rotation360";

		m_iMotorID = ID;
		m_iSize = 4;

		// ǵ  0(), 1(ּ) ~ 15(ִ)
		if( Speed > 15 )
		{
			Speed = 15;
		}
		
		else if( Speed < 0 )
		{
			Speed = 0;
		}

		m_Data[1] = ( ( 1 | 6 ) << 5 ) | ID ;
		m_Data[2] = ( ( 1 | rot ) << 4 ) | Speed ;

		MakeChecksum();
	}
};

///< P-Gain, D-Gain  Ŷ.
class CSetGain : public IPacket
{
public:
	CSetGain( int ID, int PGain, int DGain )
	{
		m_sName = "SetGain";

		m_iMotorID = ID;
		m_iSize = 6;

		m_Data[1] = ( ( 1 | 7 ) << 5 ) | ID ;
		m_Data[2] = 0x09;
		m_Data[3] = PGain;
		m_Data[4] = DGain;

		MakeChecksum();
	}
};

///< P-Gain, D-Gain д Ŷ.
class CGetGain : public IPacket
{
public:
	CGetGain( int ID )
	{
		m_sName = "GetGain";

		m_iMotorID = ID;
		m_iSize = 6;

		m_Data[1] = ( ( 1 | 7 ) << 5 ) | ID ;
		m_Data[2] = 0x0C;
		m_Data[3] = 0x00;
		m_Data[4] = 0x00;

		MakeChecksum();
	}
};

///<   о.
class CGetMaxCurrent: public IPacket
{
public:
	CGetMaxCurrent( int ID )
	{
		m_sName = "GetMaxCurrent";

		m_iMotorID = ID;
		m_iSize = 6;

		m_Data[1] = ( ( 1 | 7 ) << 5 ) | ID ;
		m_Data[2] = 0x10;
		m_Data[3] = 0x00;
		m_Data[4] = 0x00;

		MakeChecksum();
	}
};