#pragma once

#include <windows.h>

#include <d3d9.h>
#include <d3dx9core.h>
#include <D3dx9math.h>

#include "STexture.h"

#define VFLIP	1
#define HFLIP	2

#define	CSBITMAP_AUTOFIND		0x00000001

#define GET_R( color )		( (BYTE)(color >> 16) & 0xff )
#define GET_G( color )		( (BYTE)(color >>  8) & 0xff )
#define GET_B( color )		( (BYTE)(color      ) & 0xff )

class CSBitmap : public CSTexture
{
public:
	LPD3DXSPRITE		m_pBitmap;			// Ʈ ̽

	LPDIRECT3DDEVICE9	m_pd3dDevice;		// ̽

	D3DCOLOR			m_ColorKey;			// ÷Ű

	D3DXIMAGE_INFO m_BitmapInfo;			//  ̹  


	DWORD GetBitmapWidth()		{ return m_BitmapInfo.Width; }
	DWORD GetBitmapHeight()		{ return m_BitmapInfo.Height;}



public:
	CSBitmap(void);
	~CSBitmap(void);


	void SetDevice( LPDIRECT3DDEVICE9 pd3dDevice );

	
	HRESULT		Load( LPDIRECT3DDEVICE9 pd3dDevice, LPSTR FileName, D3DCOLOR ColorKey );

	HRESULT		Create( LPDIRECT3DDEVICE9 pDevice, UINT Width, UINT Height, UINT Levels, 
						DWORD Usage, D3DFORMAT Format, D3DPOOL Pool );

	HRESULT		Draw( float x, float y, float Angle = 0.0f,
					  D3DXVECTOR2 RCenter = D3DXVECTOR2(0,0),
					  D3DXVECTOR2 Scaling = D3DXVECTOR2( 1, 1 ),
					  RECT* pSrcRect = NULL, RECT* pDestRect = NULL );

	HRESULT		Draw( RECT* pSrcRect, float x, float y, float Angle = 0.0f, 
					  D3DXVECTOR3 RCenter = D3DXVECTOR3(0,0,0), 
					  DWORD	Flip = 0,
					  D3DCOLOR Alpha = D3DCOLOR_ARGB( 0xFF, 0xFF, 0xFF, 0xFF  ) );


	void Begin();
	void End();

	void Release();
};
