#pragma once

#include <windows.h>

#include <d3d9.h>

class CSTexture
{
protected:
	LPDIRECT3DTEXTURE9		m_pTexture;

	BOOL		m_bLocked;					//  ɷ ִ°? -_-?

	DWORD		m_dwWidth;					// DX ؽķ ҷ   
	DWORD		m_dwHeight;					// DX ؽķ ҷ   

	DWORD		m_dwPitch;

	DWORD*		m_pBits;					// ؽ ޸  (-_-?)

	HRESULT		GetInformation();

public:
	CSTexture(void);
	~CSTexture(void);

	virtual	HRESULT		Load( LPDIRECT3DDEVICE9 pDevice, LPSTR szFilename );
	virtual	HRESULT		Create( LPDIRECT3DDEVICE9 pDevice, UINT Width, UINT Height, UINT Levels, 
									DWORD Usage, D3DFORMAT Format, D3DPOOL Pool );

	DWORD		GetWidth()			{ return m_dwWidth; }
	DWORD		GetHeight()			{ return m_dwHeight;}

	DWORD		GetLOD()			{ return m_pTexture->GetLOD();  }
	DWORD		SetLOD( int i )		{ return m_pTexture->SetLOD(i); }

	DWORD		GetLevelCount()		{ return m_pTexture->GetLevelCount();	}

	HRESULT		Lock();
	void		UnLock();

	DWORD*		GetBitsPointer();
	
	void		PutPixel( int x, int y, D3DCOLOR );
	void		Clear( D3DCOLOR );

	void		Release();

	HRESULT		GetDesc( int Level, D3DSURFACE_DESC *desc ) 
	{ 
		return m_pTexture->GetLevelDesc( Level, desc ); 
	}

	LPDIRECT3DTEXTURE9	GetTexture()	{ return m_pTexture; }
	HRESULT				SetTexture( LPDIRECT3DDEVICE9 pDevice );

};
