#include "StdAfx.h"
#include "SerialPort.h"
#include "PacketGenerator.h"

#include "ReceivePacket.h"
#include "PacketManager.h"

DWORD WatchCommThread( CSerialPort* pPort )
{
	bool	bResult = true;
	DWORD	dwEvent;
	OVERLAPPED 	os;

	ZeroMemory( &os, sizeof(OVERLAPPED) );

	DWORD	dwRead;		//  Ʈ 

	memset( &os, 0, sizeof(OVERLAPPED)); 

	// Event, Overap Structure . 
	if (!(os.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL))) 
		bResult = false; 

	if (!SetCommMask( pPort->GetCommHandle(), EV_RXCHAR)) 
		bResult = false; 

	if (!bResult)
	{ 
		AfxMessageBox("Error while creating WatchCommThread"); 
		return false; 
	} 

	CCriticalSection Crit;

	BYTE Buffer[4];
	int	 ReceiveCount = 0;

// Ͱ   Ŷ  2Ʈ.
#define RECEIVE_PACKET_SIZE		2

	// Ʈ ִ  ͸ ޴  Ѵ.
	while( pPort->isOpend() )
	{

		Sleep(1);

		dwEvent = 0;

		WaitCommEvent( pPort->GetCommHandle(), &dwEvent, NULL); 

//		Crit.Lock();

		// RXCHAR޼  1Ʈ о´.
		if( ( dwEvent & EV_RXCHAR ) == EV_RXCHAR )
		{
			

			dwRead = pPort->Receive( &Buffer[ ReceiveCount++ ], 1 );

			// Ŷ (2Ʈ)ŭ ޾   QUE Ѵ.
			if( ReceiveCount == RECEIVE_PACKET_SIZE )
			{				
				CReceivePacket Data = Buffer;

				Crit.Lock();
				PacketManager.ReceivePacket( Data );
				Crit.Unlock();

				ReceiveCount = 0;
			}
		}

//		Crit.Unlock();

	}

    CloseHandle(os.hEvent); 

    pPort->m_hThread = NULL; 


	return true;

}

	
	
CSerialPort::CSerialPort(void)
{
	m_sPortName = "COM1";
	m_bReceived = false;
}

CSerialPort::~CSerialPort(void)
{
}




bool CSerialPort::Open( string PortName )
{
   BOOL bSuccess;

   m_sPortName = PortName;

   m_hCom = CreateFile( m_sPortName.c_str(),
                    GENERIC_READ | GENERIC_WRITE,
                    0,    // must be opened with exclusive-access
                    NULL, // no security attributes
                    OPEN_EXISTING, // must use OPEN_EXISTING
                    FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,    // not overlapped I/O
                    NULL  // hTemplate must be NULL for comm devices
                    );

   if (m_hCom == INVALID_HANDLE_VALUE) 
   {
       // Handle the error.
       return false;
   }

   // Build on the current configuration, and skip setting the size
   // of the input and output buffers with SetupComm.
   bSuccess = GetCommState( m_hCom, &m_ComState);

   if (!bSuccess) 
   {
       return false;
   }



   // Fill in DCB: 115,200 bps, 8 data bits, no parity, and 1 stop bit.
   m_ComState.BaudRate = CBR_115200;     // set the baud rate
   m_ComState.ByteSize = 8;             // data size, xmit, and rcv
   m_ComState.Parity = NOPARITY;        // no parity bit
   m_ComState.StopBits = ONESTOPBIT;    // one stop bit
   m_ComState.fDtrControl = 0;
   m_ComState.fRtsControl = 0;

   bSuccess = SetCommState( m_hCom, &m_ComState);

   if (!bSuccess) 
      return false;
   
//	overlapped structure  ʱȭ. 
    m_osReceive.Offset = 0; 
    m_osReceive.OffsetHigh = 0; 
    if (!(m_osReceive.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL)))       
        return false; 

    m_osSend.Offset = 0; 
    m_osSend.OffsetHigh = 0; 
    if (!(m_osSend.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL))) 
        return false; 


    // Serial Port ġ InQueue, OutQueue ũ . 
    SetupComm( m_hCom, 4096, 4096);  



    // Ʈ InQueue, OutQueue ʱȭ. 
    PurgeComm( m_hCom, PURGE_TXABORT | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_RXCLEAR ); 


	COMMTIMEOUTS timeouts; // Timeout Value ϱ  ü 
    
	// timeout . 
    timeouts.ReadIntervalTimeout = 0xFFFFFFFF; 
    timeouts.ReadTotalTimeoutMultiplier = 0; 
    timeouts.ReadTotalTimeoutConstant = 0; 
    timeouts.WriteTotalTimeoutMultiplier = 2*CBR_9600 / 115200;
    timeouts.WriteTotalTimeoutConstant = 0; 

    SetCommTimeouts( m_hCom, &timeouts);


	m_bOpend = true;


	///  
	DWORD dwThreadID = 0;

	m_hThread = CreateThread( 0, 0, 
		(LPTHREAD_START_ROUTINE)WatchCommThread, this, 0, &dwThreadID); 

	if(!m_hThread) 
	{ 
		// ϸ Ʈ ݴ´ 
		Close(); 
		return false; 
	} 

	return true;
}

void CSerialPort::Close()
{
	if( isOpend() )
	{
		PurgeComm( m_hCom, PURGE_TXABORT | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_RXCLEAR); 

		CloseHandle( m_hCom );
		m_hCom = NULL;
		m_bOpend = false;
	}
}


DWORD CSerialPort::Send( BYTE *pData, int iLength )
{

	DWORD dwWritten, dwErrorFlags; 
	COMSTAT comstat; 
	BOOL bSuccess = FALSE;

	
//	if( m_CriticalSection.Lock() )
	{
		bSuccess = WriteFile( m_hCom, (VOID*)pData, iLength, &dwWritten, &m_osSend );
		m_bReceived = false;


		if( !bSuccess )
		{
			if( GetLastError() == ERROR_IO_PENDING )
			{
				//  ڰ  ְų  ڰ    Overapped IO 
				// Ư  ERROR_IO_PENDING  ޽ ޵ȴ. 
				// timeouts  ðŭ ٷش. 

				while (!GetOverlappedResult( m_hCom, &m_osSend, &dwWritten, TRUE)) 
				{ 
					if (GetLastError() != ERROR_IO_INCOMPLETE) 
					{ 
						ClearCommError( m_hCom, &dwErrorFlags, &comstat); 
						break; 
					} 
				} 
			} 
			else 
			{ 
				dwWritten = 0; 
				ClearCommError( m_hCom, &dwErrorFlags, &comstat); 
			} 
		} 
	}

//	m_CriticalSection.Unlock();

	return dwWritten; 

} 



DWORD CSerialPort::Receive( BYTE *pBuffer, int Length )
{

	DWORD dwRead = -1, dwError, dwErrorFlags; 
    COMSTAT comstat; 

//	if( m_CriticalSection.Lock() )
	{
		ClearCommError( m_hCom, &dwErrorFlags, &comstat); 

		// input Queue  ִ   
		dwRead = comstat.cbInQue; 


		if( dwRead > 0 )
		{
			if( !ReadFile( m_hCom, pBuffer, Length, &dwRead, &m_osReceive ) )
			{
				AfxMessageBox( "  о!!!!!!!" );

				if (GetLastError() == ERROR_IO_PENDING)
				{
					//  Ͱ ִ  timeouts  ðŭ ٷش.
					while (! GetOverlappedResult( m_hCom, &m_osReceive, &dwRead, TRUE))
					{
						dwError = GetLastError();

						if (dwError != ERROR_IO_INCOMPLETE)
						{
							ClearCommError( m_hCom, &dwErrorFlags, &comstat);
							break;
						}
					}
				}
				else
				{
					return 0;
					ClearCommError( m_hCom, &dwErrorFlags, &comstat);
				}
			}
		}
	}

//	m_CriticalSection.Unlock();

	return dwRead;

	
}


void CSerialPort::ClearBuffer()
{
	if( m_CriticalSection.Lock() )
		PurgeComm( m_hCom, PURGE_RXCLEAR ); 
	m_CriticalSection.Unlock();
}




/**
	@remarks
	
	@param IPacket Packet
	@return DWORD 
	@date 2004 7 1   4:27:47
*/
DWORD CSerialPort::Send( IPacket Packet )
{
//	if( m_CriticalSection.Lock() )
		return Send( Packet.GetBuffer(), Packet.GetSize() );

//	m_CriticalSection.Unlock();
}


/**
	@remarks
		־ (и)ŭ ̸ ش.
	
	@param	DWORD dwMS		Milli Seconds
	
	@return void 
	
	@author Star.
	@date   2004 7 12   4:21:39
*/
void CSerialPort::Delay( DWORD dwMS )
{
	Sleep( dwMS );
}
