#pragma once

#include <string>
#include <deque>
#include <assert.h>

#include <afxmt.h>

#include "Singleton.h"

using namespace std;
using namespace Loki;

class IPacket;
class CSerialPort;
class CPacketManager;

DWORD WatchCommThread( CSerialPort* pPort );

class CSerialPort
{
	string	m_sPortName;		///< Ʈ ̸
	bool	m_bReceived;		///< ͸ ޾ҳ?
	bool	m_bOpend;			///< Ʈ ȳ?
	DCB		m_ComState;			///< Ʈ (?) 

	HANDLE	m_hCom;				///< Ʈ ڵ
	HANDLE	m_hThread;			///<  ڵ

	OVERLAPPED	m_osSend;
	OVERLAPPED	m_osReceive;

	CCriticalSection m_CriticalSection;		///< ũƼ 

private:
	friend DWORD WatchCommThread( CSerialPort* pPort );
	friend class CPacketManager;

	DWORD	Receive( BYTE *pBuffer, int Length ); ///<  ͸ о. 

	DWORD	Send( IPacket );									///< Ŷ   Ŷ 
	DWORD	Send( BYTE *pData, int Length );			///<  

public:
	CSerialPort(void);
	~CSerialPort(void);

public:

	///< Ʈ ִ°?
	bool	isOpend()
	{
		return m_bOpend;
	}

	///< 
	bool	IsReceived()
	{
		return m_bReceived;
	}

	///< Ʈ ̸ .
	const string&	GetPortName()
	{
		return m_sPortName;
	}

	///< COM Port ڵ ȯ.
	HANDLE	GetCommHandle()
	{
		return m_hCom;
	}

	///< Milli Seconds  ̸ ִ Լ.
	void Delay( DWORD dwMS );


public:
	friend class SingletonHolder< CSerialPort >;

	bool	Open( string port = "COM1" );				///< Ʈ .
	void	Close();									///< Ʈ ݴ´.

	void	ClearBuffer();
};


typedef SingletonHolder< CSerialPort >	SingleCSerialPort;
#define	 g_SerialPort					SingleCSerialPort::Instance()