// MainFrm.cpp : CMainFrame Ŭ 
//

#include "stdafx.h"
#include "Baram2.h"

#include "Mainfrm.h"

#include "MySheet.h"
#include "BaramView.h"

#include "OptionManager.h"
#include ".\mainfrm.h"

#include "Page3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_IDEDIT, OnIdedit)
	ON_COMMAND(ID_CONNECT, OnConnect)
	ON_COMMAND(ID_COMBO_COMPORT, OnComboComport)

	ON_UPDATE_COMMAND_UI(ID_CONNECT, OnUpdateConnect)
	ON_UPDATE_COMMAND_UI(ID_COMBO_COMPORT, OnUpdateComport)
	ON_COMMAND(ID_BMONITORING, OnBmonitoring)
	ON_UPDATE_COMMAND_UI(ID_BMONITORING, OnUpdateBmonitoring)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           //   ǥñ
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame /Ҹ

CMainFrame::CMainFrame()
{
	g_PaintManager.InstallPaintManager( RUNTIME_CLASS(CExtPaintManagerOffice2003) );
	//g_PaintManager.InstallPaintManager( RUNTIME_CLASS(CExtPaintManagerXP) );
	

	// window placement persistence
	::memset( &m_dataFrameWP, 0, sizeof(WINDOWPLACEMENT) );
	m_dataFrameWP.length = sizeof(WINDOWPLACEMENT);
	m_dataFrameWP.showCmd = SW_HIDE;

	OptionManager.AddStringOption( "COMPORT", "COM1" );
	OptionManager.AddBoolOption( "CONNECTED", false );	
	OptionManager.AddBoolOption( "MONITORING", false );

}

CMainFrame::~CMainFrame()
{
	SAFE_DELETE( m_pSheet );

	SAFE_DELETE( m_pPage1 );
	SAFE_DELETE( m_pPage2 );
	SAFE_DELETE( m_pPage3 );

//	SAFE_DELETE( m_pBaramView );
}


static UINT g_statBasicCommands[] =
{
	ID_FILE_NEW, 
	ID_FILE_OPEN, 
	ID_FILE_SAVE,
	ID_FILE_SAVE_AS,
	ID_VIEW_STATUS_BAR,
	ID_APP_EXIT,
	ID_APP_ABOUT,
	ID_FILE_PRINT,
	ID_EDIT_COPY, 
	ID_EDIT_CUT, 
	ID_EDIT_PASTE, 
	ID_EDIT_UNDO, 
	ID_VIEW_TOOLBAR, 
	ID_COMBO_COMPORT,
	ID_CONNECT,
	ID_BMONITORING,
	0 // end of commands list
}; // statBasicCommands array



int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
/*	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("   ߽ϴ.\n");
		return -1;      //  ߽ϴ.
	}
*/
	CWinApp * pApp = ::AfxGetApp();
	ASSERT( pApp != NULL );
	ASSERT( pApp->m_pszRegistryKey != NULL );
	ASSERT( pApp->m_pszRegistryKey[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );
	ASSERT( pApp->m_pszProfileName[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );


	HICON hIcon = pApp->LoadIcon( IDR_MAINFRAME );

	ASSERT( hIcon != NULL );
	SetIcon( hIcon, TRUE );
	SetIcon( hIcon, FALSE );
	

	g_CmdManager->ProfileSetup(
		pApp->m_pszProfileName,
		GetSafeHwnd()
		);


	VERIFY(
		g_CmdManager->ProfileWndAdd(
			pApp->m_pszProfileName,
			GetSafeHwnd()
			)
		);

	VERIFY(
		g_CmdManager->UpdateFromMenu(
			pApp->m_pszProfileName,
			IDR_MAINFRAME
			)
		);



	if(!m_wndMenuBar.Create( NULL, 	this )	)
	{
		TRACE0("Failed to create menubar\n");
		return -1; 
	}


	if( !m_wndToolBar.Create( _T( "Toolbar" ),	this, IDR_MAINFRAME )
			|| !m_wndToolBar.LoadToolBar( IDR_MAINFRAME )
		)
	{
		TRACE0( "Failed to create toolbar1" );
		return -1;
	}


	if( !m_wndToolBar2.Create( _T( "Toolbar2" ),	this, IDR_OPTION_TOOLBAR )
			|| !m_wndToolBar2.LoadToolBar( IDR_OPTION_TOOLBAR )
		)
	{
		TRACE0( "Failed to create toolbar2" );
		return -1;
	}

CExtCmdItem * pCmdItem;

	pCmdItem =
		g_CmdManager->CmdGetPtr(
			pApp->m_pszProfileName,
			ID_CONNECT
			);
	ASSERT( pCmdItem != NULL );
	pCmdItem->m_sToolbarText = _T("");


	pCmdItem =
		g_CmdManager->CmdGetPtr(
			pApp->m_pszProfileName,
			ID_BMONITORING
			);
	ASSERT( pCmdItem != NULL );
	pCmdItem->m_sToolbarText = _T("͸ Ȱȭ");



	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0(" ǥ  ߽ϴ.\n");
		return -1;      //  ߽ϴ.
	}


	m_wndControlBar.SetInitDesiredSizeVertical( CSize(570,200) );
	m_wndControlBar.SetInitDesiredSizeHorizontal( CSize(200,150) );

	if(	!m_wndControlBar.Create(
			"Control View",
			this
			//&m_wndToolBar
			)
		)
	{
		TRACE0("Failed to create m_wndResizableBarPS1\n");
		return -1;
	}

	CRect Rect;
	this->GetClientRect( Rect );

	m_wndControlBar2.SetInitDesiredSizeVertical( CSize( 710,200) );
	m_wndControlBar2.SetInitDesiredSizeHorizontal( CSize(200,150) );

	if(	!m_wndControlBar2.Create(
			"3D Simulation View",
			this
			)
		)
	{
		TRACE0("3D Simulation View\n");
		return -1;
	}



	m_pPage1 = new CPage1;
	m_pPage2 = new CPage2;
	m_pPage3 = new CPage3;

	m_pSheet = new CExtChildResizablePropertySheet();

	m_pSheet->AddPage( m_pPage1 );
	m_pSheet->AddPage( m_pPage2 );
	m_pSheet->AddPage( m_pPage3 );
	m_pSheet->Create( &m_wndControlBar );

	m_pBaramView = new CBaramView;

/*	if(	!((CWnd*)m_pBaramView)->Create(
			NULL,
			NULL,
			WS_CHILD | WS_VISIBLE,
			CRect( 0, 0, 0, 0 ),
			&m_wndControlBar2,
			AFX_IDW_PANE_FIRST,
			NULL
			)
		)

*/
/*
	if( !((CD3DApplication*)m_pBaramView)->Create( AfxGetInstanceHandle() ) )
	{
		ASSERT( FALSE );
		TRACE0("Failed to create view window\n");
		return -1;
	}
*/	

	if( !(m_pBaramView->Create( &m_wndControlBar2 )) )
	{
		ASSERT( FALSE );
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	//m_pBaramView->Create( AfxGetApp()->m_hInsta

	m_wndMenuBar.EnableDocking( CBRS_ALIGN_ANY );
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar2.EnableDocking(CBRS_ALIGN_ANY);
	//m_wndControlBar.EnableDocking( CBRS_ALIGN_ANY );
	m_wndControlBar.EnableDocking( CBRS_ALIGN_RIGHT );
	m_wndControlBar2.EnableDocking( CBRS_ALIGN_LEFT );

	if( !CExtControlBar::FrameEnableDocking(this) )
	{
		ASSERT( FALSE );
		return -1;
	}

	VERIFY(
		g_CmdManager->SetBasicCommands(
			pApp->m_pszProfileName,
			g_statBasicCommands
			)
		);


/*
	if( !CExtControlBar::ProfileBarStateLoad(
			this,
			pApp->m_pszRegistryKey,
			pApp->m_pszProfileName,
			pApp->m_pszProfileName,
			&m_dataFrameWP
			)
		)*/
	{
		DockControlBar( &m_wndMenuBar );
		DockControlBar( &m_wndToolBar );
//		DockControlBar( &m_wndToolBar2 );
		RecalcLayout();

		// 2 1 ʿ docking		
		CRect wrAlredyDockedBar;
		m_wndToolBar.GetWindowRect( &wrAlredyDockedBar );
		wrAlredyDockedBar.OffsetRect( 10, 0 );
		DockControlBar( &m_wndToolBar2, AFX_IDW_DOCKBAR_TOP, &wrAlredyDockedBar );


		m_wndControlBar.DockControlBar ( AFX_IDW_DOCKBAR_RIGHT,  1, this, false );
		m_wndControlBar2.DockControlBar( AFX_IDW_DOCKBAR_LEFT,   1, this, false );
	}

	g_CmdManager->SerializeState(
		pApp->m_pszProfileName,
		pApp->m_pszRegistryKey,
		pApp->m_pszProfileName,
		false
		);

	m_ComboComport.Create( WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST, CRect( 0, 0, 70, 400 ), &m_wndToolBar2, ID_COMBO_COMPORT );
	m_wndToolBar2.SetButtonCtrl( m_wndToolBar2.CommandToIndex( ID_COMBO_COMPORT ), &m_ComboComport );

	CExtComboBox* pButton = (CExtComboBox*)m_wndToolBar2.GetButtonCtrl( m_wndToolBar2.CommandToIndex( ID_COMBO_COMPORT ) );

	m_ComboComport.SetItemHeight( 0, 15 );

	m_ComboComport.AddString( "COM1" );
	m_ComboComport.AddString( "COM2" );
	m_ComboComport.AddString( "COM3" );
	m_ComboComport.AddString( "COM4" );

	m_ComboComport.SetCurSel( 0 );
	m_ComboComport.SetFont( CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)) );



	m_ComboComport.ShowWindow( SW_SHOW );
	
	
//	m_wndToolBar2.SetButtonInfo( m_wndToolBar2.CommandToIndex( ID_COMBO_COMPORT ), ID_COMBO_COMPORT, 
//		TBBS_DROPDOWN | TBBS_SEPARATOR | TBBS_BUTTON );
//	m_wndToolBar.Get

	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
/*	if(!m_wndSplitter.CreateStatic(this, 1, 2, 
		WS_CHILD | WS_VISIBLE | AFX_IDW_PANE_FIRST ))
		return FALSE;

	if( !m_wndSplitter.CreateView( 0, 0, RUNTIME_CLASS(CBaramView), CSize( 20, 180 ), pContext ) )
	{
		return FALSE;
	} 

	if( !m_wndSplitter.CreateView( 0, 1, RUNTIME_CLASS(CRightView), CSize( 20, 180 ), pContext ) )
	{
		return FALSE;
	}

	CRect rect;
	GetClientRect( &rect );

	m_wndSplitter.SetColumnInfo( 0, ( GetSystemMetrics(SM_CXSCREEN) / 100 ) * 55, 10 );

	m_pBaramView = (CBaramView*)m_wndSplitter.GetPane( 0, 0 );
//	m_pRightView = (CRightView*)m_wndSplitter.GetPane( 0, 1 );

	this->RecalcLayout(); */

	
	return TRUE;

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		 | WS_THICKFRAME | WS_SYSMENU;

	return TRUE;
}


// CMainFrame 

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame ޽ ó


void CMainFrame::OnIdedit()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	
//	CPage1* pPage1 = (CPage1*)((CRightView*)m_wndSplitter.GetPane( 0, 1 ))->m_pSheet->GetPage(0);

	CPage1* pPage1 = (CPage1*)m_pSheet->GetPage(0);
	pPage1->OnIdedit();
}

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
    if( m_wndMenuBar.TranslateMainFrameMessage(pMsg) )
        return TRUE;

	return CFrameWnd::PreTranslateMessage(pMsg);
}

void CMainFrame::ActivateFrame(int nCmdShow)
{
	// window placement persistence
	if( m_dataFrameWP.showCmd != SW_HIDE )
	{
		SetWindowPlacement( &m_dataFrameWP );
		CFrameWnd::ActivateFrame( m_dataFrameWP.showCmd );
		m_dataFrameWP.showCmd = SW_HIDE;
		return;
	}
	
	CFrameWnd::ActivateFrame(nCmdShow);
}

BOOL CMainFrame::DestroyWindow()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	CWinApp * pApp = ::AfxGetApp();
	ASSERT( pApp != NULL );
	ASSERT( pApp->m_pszRegistryKey != NULL );
	ASSERT( pApp->m_pszRegistryKey[0] != _T('\0') );
	ASSERT( pApp->m_pszProfileName != NULL );
	ASSERT( pApp->m_pszProfileName[0] != _T('\0') );
	VERIFY(
		CExtControlBar::ProfileBarStateSave(
		this,
		pApp->m_pszRegistryKey,
		pApp->m_pszProfileName,
		pApp->m_pszProfileName
		)
		);

	g_CmdManager->ProfileWndRemove( GetSafeHwnd() );

	return CFrameWnd::DestroyWindow();
}

void CMainFrame::OnConnect()
{
	bool bConnected = OptionManager.GetBoolOption( "CONNECTED" );

	OptionManager.SetBoolOption( "CONNECTED", !bConnected );

	CExtCmdItem * pCmdItem;

	pCmdItem =
		g_CmdManager->CmdGetPtr(
			AfxGetApp()->m_pszProfileName,
			ID_CONNECT
			);
	ASSERT( pCmdItem != NULL );

	( OptionManager.GetBoolOption( "CONNECTED" ) ) ?
		pCmdItem->m_sToolbarText = _T("") :
		pCmdItem->m_sToolbarText = _T("");
}


void CMainFrame::OnUpdateConnect(CCmdUI *pCmdUI)
{
	// TODO: ⿡  Ʈ UI ó ڵ带 ߰մϴ.
	//pCmdUI->SetRadio( ( OptionManager.GetBoolOption( "CONNECTED" ) ) : FALSE ? TRUE );
	//pCmdUI->Enable( !OptionManager.GetBoolOption( "CONNECTED" ) );
	//pCmdUI->SetCheck( OptionManager.GetBoolOption( "CONNECTED" ) );
}

void CMainFrame::OnComboComport()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	int Num = m_ComboComport.GetCurSel() + 1;

	string str = "COM";
	str += Num;

	OptionManager.SetStringOption( "COMPORT", str );

}

void CMainFrame::OnUpdateComport(CCmdUI *pCmdUI)
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	int Num = m_ComboComport.GetCurSel() + 1;

	string str = "COM";
	str += Num;

	OptionManager.SetStringOption( "COMPORT", str );
}
void CMainFrame::OnBmonitoring()
{
	bool bMonitoring = OptionManager.GetBoolOption( "MONITORING" );
	OptionManager.SetBoolOption( "MONITORING", !bMonitoring );
}

void CMainFrame::OnUpdateBmonitoring(CCmdUI *pCmdUI)
{
	bool bMonitoring = OptionManager.GetBoolOption( "MONITORING" );

	pCmdUI->SetCheck( bMonitoring );
}
